"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  createOverlay: () => createOverlay,
  default: () => src_default,
  install: () => install,
  renderOverlay: () => renderOverlay,
  useOverlayMeta: () => useOverlayMeta
});
module.exports = __toCommonJS(src_exports);

// src/internal/index.ts
var context = {
  appContext: null
};
var OverlayMetaKey = Symbol("__imperative_overlay_key");

// src/hooks/meta.ts
var import_vue_demi = require("vue-demi");
var import_core = require("@vueuse/core");

// src/utils/index.ts
function delay(milliseconds) {
  return new Promise((resolve) => setTimeout(resolve, milliseconds));
}
function createPromiser() {
  let resolve;
  let reject;
  const promise = new Promise((_resolve, _reject) => {
    resolve = _resolve;
    reject = _reject;
  });
  return { promise, reject, resolve };
}
function noop() {
}
function allowed() {
  throw new Error("overlay - Error: It is not allowed to call confirm and cancel externally immediately, please wait for the component to render");
}
var portalIndex = 1;
function createGlobalNode(id, root = document.body) {
  const el = document.createElement("div");
  el.id = `${id}--${portalIndex++}`;
  root.appendChild(el);
  return el;
}

// src/hooks/meta.ts
function useOverlayMeta(options = {}) {
  const { animation = 0, immediate = true, model = "visible", automatic = true } = options;
  const defaultMeta = getTemplateMeta(model, options);
  const meta = (0, import_vue_demi.inject)(OverlayMetaKey, defaultMeta) || defaultMeta;
  if (!meta.isTemplate && automatic) {
    (0, import_vue_demi.watch)(meta.visible, async () => {
      var _a;
      if (meta.visible.value)
        return void 0;
      if (animation > 0)
        await delay(animation);
      (_a = meta.vanish) == null ? void 0 : _a.call(meta);
    });
  }
  if (immediate)
    (0, import_vue_demi.onMounted)(() => meta.visible.value = true);
  (0, import_vue_demi.provide)(OverlayMetaKey, null);
  return meta;
}
function getTemplateMeta(model, options = {}) {
  const instance = (0, import_vue_demi.getCurrentInstance)();
  const visible = instance ? (0, import_core.useVModel)(instance.props, model) : (0, import_vue_demi.ref)(false);
  const cancel = (value) => {
    visible.value = false;
    instance == null ? void 0 : instance.emit(options.cancel || "cancel", value);
  };
  const confirm = (value) => {
    visible.value = false;
    instance == null ? void 0 : instance.emit(options.confirm || "confirm", value);
  };
  return {
    cancel,
    confirm,
    vanish: noop,
    visible,
    isTemplate: true
  };
}

// src/hooks/visible.ts
var import_vue = require("vue");
function useVisible(promiser, _vanish) {
  const { reject, resolve, promise } = promiser;
  const visible = (0, import_vue.ref)(false);
  function cancel(value) {
    reject == null ? void 0 : reject(value);
    visible.value = false;
  }
  function confirm(value) {
    resolve == null ? void 0 : resolve(value);
    visible.value = false;
  }
  function vanish() {
    _vanish == null ? void 0 : _vanish();
    reject == null ? void 0 : reject();
  }
  promise.confirm = confirm;
  promise.cancel = cancel;
  return { visible, confirm, cancel, vanish };
}

// src/transform/index.ts
var import_vue_demi3 = require("vue-demi");

// src/helper/render.ts
var import_vue_demi2 = require("vue-demi");
var renderInstance = (component, props, options = {}) => {
  const vanish = () => {
    (0, import_vue_demi2.render)(null, container);
  };
  const name = `${component.name}OverlayProvider`;
  const Provider = (0, import_vue_demi2.defineComponent)({
    name,
    setup() {
      var _a;
      (_a = options.setup) == null ? void 0 : _a.call(options);
    },
    render() {
      return (0, import_vue_demi2.h)(component, props);
    }
  });
  const container = createGlobalNode(name);
  const vnode = (0, import_vue_demi2.createVNode)(Provider);
  vnode.appContext = options.appContext || context.appContext;
  (0, import_vue_demi2.render)(vnode, container);
  if (container.firstElementChild) {
    const root = options.root || document.body;
    root.append(container.firstElementChild);
  }
  return { vanish, vnode };
};

// src/transform/index.ts
function createOverlay(component) {
  function executor(props, promiser, options) {
    let vanish;
    function setup() {
      (0, import_vue_demi3.provide)(OverlayMetaKey, useVisible(promiser, vanish));
    }
    ({ vanish } = renderInstance(component, props, { ...options, setup }));
  }
  function caller(props, options) {
    const promiser = createPromiser();
    promiser.promise.confirm = allowed;
    promiser.promise.cancel = allowed;
    executor(props, promiser, options);
    return promiser.promise;
  }
  return caller;
}
function renderOverlay(component, options = {}) {
  return createOverlay(component)(options.props, options);
}

// src/index.ts
var install = (app) => {
  context.appContext = app._context;
};
var unoverlay = { install };
var src_default = unoverlay;
//# sourceMappingURL=index.cjs.js.map
